import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class QRDecomp extends Frame
{  public QRDecomp()
   {  setSize(800,300);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public void MultM(double [][] A,double [][] B,double [][] C,int N1,int N2, int N3)
   {  int i,j,k;
      for(i=0;i<N1;i++) for(j=0;j<N3; j++)
      {  C[i][j]=0.0;
         for(k=0;k<N2;k++) C[i][j] += A[i][k] * B[k][j];
      }
   }
   public void QR_D(double [][] A,double [][] Q,double [][] R,int N)
   { int i, j, k; double Rjk, T;
     double [] X = new double[N];
     for(k = 0; k < N; k++)
     { for(i = 0; i < N; i++) X[i] =A[i][k];
       for(j = 0; j <= k-1; j++)
       {  Rjk = 0;
          for(i = 0; i < N; i++) Rjk += A[i][k] * Q[i][j];
          R[j][k] = Rjk; R[k][j] = 0;
          for(i = 0; i < N; i++) X[i] -= Rjk * Q[i][j];
       }  
       T = 0;for(i=0;i<N;i++) T += X[i] * X[i];
       R[k][k] = Math.sqrt(T);
       for(j = 0; j < N; j++) Q[j][k] = X[j] / R[k][k];
     }
   }
   public void drawBra(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X + 2,Y);g.drawLine( X,Y + H, X + 2, Y + H);
   }
   public void drawKet(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X - 2,Y);g.drawLine( X,Y + H, X - 2, Y + H);
   }
   private double round(double D,int N)
   {  double DN=10*Math.pow(10.0,(double)(N-1));
      return Math.rint(D*DN)/DN;
   }
   public void DrawExp(Graphics g, String ope1,String ope2, int Y,
                       double [][] A,double [][] B,double [][] C,int N1,int N2)
   {  int i, j;
      g.drawString( ope1,205,Y+20);
      g.drawString( ope2,405,Y+20);
      for(i=0;i<N1;i++) for(j=0;j<N2; j++)
      {  g.drawString( "" + round(A[i][j],3), 50 + j*50,Y + i*20);
         g.drawString( "" + round(B[i][j],3),250 + j*50,Y + i*20);
         g.drawString( "" + round(C[i][j],3),450 + j*50,Y + i*20);
      }
      drawBra(g, 40, Y - 10, 50); drawKet(g,190, Y - 10, 50);
      drawBra(g,240, Y - 10, 50); drawKet(g,390, Y - 10, 50);
      drawBra(g,440, Y - 10, 50); drawKet(g,590, Y - 10, 50);
   } 
   public void paint(Graphics g)
   {  int i,j;
      double [][] A={{1,-2,2},{-2,1,1},{-2,1,2}};
      double [][] L={{0,0,0},{0,0,0},{0,0,0}};
      double [][] U={{0,0,0},{0,0,0},{0,0,0}};
      double [][] C={{0,0,0},{0,0,0},{0,0,0}};
      setTitle("DR");
      QR_D(A, L, U, 3);
      DrawExp(g, "","", 50, A, L, U, 3,3);
      MultM(L, U, C, 3, 3, 3);
      DrawExp(g, "","", 150, L, U, C, 3,3);
   } 
   public static void main(String[] args)
   {  Frame w = new QRDecomp();
      w.setVisible(true);
   }
}
